mod Maux

incl Mtex

rem 
  \para \bf  Characteristic function.  \end 

appldisp/2 Tex_f2_char_eqf
  Infix(Arg(0),24,0,Subsup(Op('=',0),75,Op('*',0),None),Arg(1))

fun/2 Eqf 'Tex_f2_char_eqf'
  Eqf(x,y) = 1 <- x = y
  Eqf(x,y) = 0 <- x != y

rem 
  \para \bf  Catalan pairing function.  \end 

rem 
  \para \it  Projection functions.  \end 

fun Proj1 'Tex_f1_pp_proj1'
  Proj1(0) = 0
  Proj1(v,w) = v

fun Proj2 'Tex_f1_pp_proj2'
  Proj2(0) = 0
  Proj2(v,w) = w

rem 
  \para \it  Unary iteration of the second projection.  \end 

fun/2 Iproj2 'Tex_f2_pp_iproj2'
  Iproj2(0,x) = x
  Iproj2(n+1,x) = Iproj2(n,Proj2(x))

rem 
  \para \bf  N-tuples.  \end 

pred/2 Tuple 
  Tuple(n,x) <-> n = 0 & x = 0 \/ n = 1 \/ n >= 2 & Iproj2(n-2,x) != 0

fun/3 Proj 'Tex_f3_pp_proj'
  Proj(n,x,i) = Proj1 Iproj2(i-1,x) <- i < n
  Proj(n,x,i) = Iproj2(n-1,x) <- i >= n

rem 
  \para \bf  Lists.  \end 

fun L 
  L(0) = 0
  L(v,w) = L(w)+1

fun/2 Sub 'Tex_f2_ln_sub'
  Sub(x,i) = Proj1 Iproj2(i,x)

fun/2 Count 'Tex_f2_ln_count'
  Count(a,0) = 0
  Count(a,v,w) = Count(a,w)+Eqf(a,v)

